//
//  MDTimerManager.h
//  MuduLibrary
//
//  Created by mac-zwj on 2022/2/24.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface MDTimerManager : NSObject

/**
 开启定时器，注意action中要弱引用
 */
- (void)startTimerWithName:(NSString*)timerName interval:(NSTimeInterval)interval queue:(nullable dispatch_queue_t)queue repeats:(BOOL)repeats action:(dispatch_block_t)action;

/**
 暂停定时器
 */
- (void)pauseTimerWithName:(NSString*)timerName;

/**
 恢复定时器
 */
- (void)resumeTimerWithName:(NSString*)timerName;

/**
 移除定时器
 */
- (void)removeTimerWithName:(NSString*)timerName;

/**
 是否已经包含了timerName
 */
- (BOOL)containTimer:(NSString*)timerName;

@end

NS_ASSUME_NONNULL_END
