//
//  NSArray+MDSafeAccess.h
//  MuduLibrary
//
//  Created by mac-zwj on 2021/8/20.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

#pragma --mark NSMutableArray

@interface NSArray (MDSafeAccess)

- (id)md_firstObject;
- (id)md_lastObject;
- (id)md_objectAtIndex:(NSUInteger)index;
- (NSArray *)md_objectsAtIndexes:(NSIndexSet *)indexes;
- (id)md_objectAtIndexedSubscript:(NSUInteger)idx;


@end




#pragma --mark NSMutableArray

@interface NSMutableArray(SafeAccess)

- (void)md_addObject:(id)obj;
- (void)md_insertObject:(id)obj atIndex:(NSUInteger)index;
- (void)md_removeLastObject;
- (void)md_removeObjectAtIndex:(NSUInteger)index;
- (void)md_replaceObjectAtIndex:(NSUInteger)index withObject:(id)anObject;
- (void)md_addObjectsFromArray:(NSArray *)otherArray;
- (void)md_exchangeObjectAtIndex:(NSUInteger)idx1 withObjectAtIndex:(NSUInteger)idx2;
- (void)md_removeAllObjects;
- (void)md_removeObject:(id)anObject inRange:(NSRange)range;
- (void)md_removeObject:(id)anObject;
- (void)md_removeObjectsInArray:(NSArray *)otherArray;
- (void)md_removeObjectsInRange:(NSRange)range;
- (void)md_replaceObjectsInRange:(NSRange)range withObjectsFromArray:(NSArray *)otherArray range:(NSRange)otherRange;
- (void)md_replaceObjectsInRange:(NSRange)range withObjectsFromArray:(NSArray *)otherArray;

@end

NS_ASSUME_NONNULL_END
