//
//  NSDictionary+MDSafeAccess.h
//  BuguInteractiveSDK
//
//  Created by Apple on 2020/9/19.
//  Copyright © 2020 Apple. All rights reserved.
//

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@interface NSDictionary (MDSafeAccess)

- (BOOL)md_hasKey:(id)key;

- (BOOL)md_hasValue:(id)value;

- (id)md_objectForKey:(id)key;

- (NSString*)md_stringForKey:(id)key;

- (NSNumber*)md_numberForKey:(id)key;

- (NSDecimalNumber *)md_decimalNumberForKey:(id)key;

- (NSArray*)md_arrayForKey:(id)key;

- (NSDictionary*)md_dictionaryForKey:(id)key;

- (NSInteger)md_integerForKey:(id)key;

- (NSUInteger)md_unsignedIntegerForKey:(id)key;

- (BOOL)md_boolForKey:(id)key;

- (int)md_intForKey:(id)key;

- (int16_t)md_int16ForKey:(id)key;

- (int32_t)md_int32ForKey:(id)key;

- (int64_t)md_int64ForKey:(id)key;

- (char)md_charForKey:(id)key;

- (short)md_shortForKey:(id)key;

- (float)md_floatForKey:(id)key;

- (double)md_doubleForKey:(id)key;

- (long long)md_longLongForKey:(id)key;

- (unsigned long long)md_unsignedLongLongForKey:(id)key;

- (NSDate *)md_dateForKey:(id)key dateFormat:(NSString *)dateFormat;

//CG
- (CGFloat)md_CGFloatForKey:(id)key;

- (CGPoint)md_pointForKey:(id)key;

- (CGSize)md_sizeForKey:(id)key;

- (CGRect)md_rectForKey:(id)key;
@end

#pragma --mark NSMutableDictionary setter

@interface NSMutableDictionary(SafeAccess)

-(void)md_setObject:(id)obj forKey:(id)key;

-(void)md_setDictionary:(NSDictionary *)dic forKey:(id)key;

-(void)md_setArray:(NSArray *)array forKey:(id)key;

-(void)md_setString:(NSString*)i forKey:(id)key;

-(void)md_setBool:(BOOL)i forKey:(id)key;

-(void)md_setInt:(int)i forKey:(id)key;

-(void)md_setInteger:(NSInteger)i forKey:(id)key;

-(void)md_setUnsignedInteger:(NSUInteger)i forKey:(id)key;

-(void)md_setCGFloat:(CGFloat)f forKey:(id)key;

-(void)md_setChar:(char)c forKey:(id)key;

-(void)md_setFloat:(float)i forKey:(id)key;

-(void)md_setDouble:(double)i forKey:(id)key;

-(void)md_setLongLong:(long long)i forKey:(id)key;

-(void)md_setPoint:(CGPoint)o forKey:(id)key;

-(void)md_setSize:(CGSize)o forKey:(id)key;

-(void)md_setRect:(CGRect)o forKey:(id)key;


- (void)md_removeObjectForKey:(id)key;


@end

NS_ASSUME_NONNULL_END
